/*
 *	@(#)load_command.c (usermain_t2ex)
 *
 *	Copyright (C) 2013 by Personal Media Corporation
 */
#include <t2ex/load.h>

LOCAL	void	cmd_load(INT ac, B *av[])
{
	struct pm	prog;
	ID	progid;
	INT	spg;
	UINT	attr;
	pm_entry_t	*entry;
	struct pm_stat	status;

	if (ac < 2) return;

	spg = (strcmp( av[0], "loadspg" ) == 0);
	prog.pmtype = PM_FILE;
	prog.pmhdr = av[1];

	if (spg) {
		progid = pm_loadspg( &prog, ac - 1, (UB**)(av + 1) );
		if (progid >= E_OK) {
			P("pm_loadspg: progid:%d\n", progid);
		} else {
			P("pm_loadspg: ERR [%#x]\n", progid);
		}
	} else {
		attr = (ac >= 3 ? strtol( av[2], NULL, 0 ) * TA_RNG1 : TA_RNG3);
		progid = pm_load( &prog, attr, &entry );
		if (progid >= E_OK) {
			P("pm_load: progid:%d entry:%p\n", progid, entry);
		} else {
			P("pm_load: ERR [%#x]\n", progid);
		}
	}
	if (progid >= E_OK &&
		pm_status( progid, &status ) >= E_OK) {
		P( "sysprg:%d attr:%d entry:%p start:%p end:%p\n", status.sysprg, status.attr / TA_RNG1, status.entry, status.start, status.end );
	}
}

LOCAL	void	cmd_unload(INT ac, B *av[])
{
	ID	progid;
	ER	er;

	if (ac < 2) return;

	progid = strtol( av[1], NULL, 0 );
	er = pm_unload( progid );
	if (er >= E_OK) {
		P("pm_unload(%d) OK\n", progid);
	} else {
		P("pm_unload(%d) ERR [%#x]\n", progid, er);
	}
}
