/*
 *	@(#)web_command.c (usermain_t2ex)
 *
 *	Copyright (C) 2013 by Personal Media Corporation
 */

#include <basic.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <tk/syscall.h>
#include <tk/util.h>
#include <t2ex/fs.h>

#include "network_sample/util.h"
#include "apd_cmd.h"

#ifdef	USE_T2EX_FS
#define	P		printf
#else
#define	P		tm_printf
#endif

#define	CRLF	"\r\n"			/* 				*/

LOCAL ID	tid;			/* ID			*/
LOCAL B		buf1[1024];		/* Хåե		*/
LOCAL B		buf2[512];
LOCAL B		*autoback = "<html>"
			    "<head></head>"
			    "<body onLoad=\"history.back()\">%s</body>"
			    "</html>" CRLF;
LOCAL B		rootpath[PATH_MAX];

struct {
	B *key;
	FP	func;
} key_func[] ={
	{"start",	start},
	{"stop",	stop},
	{"up",		up},
	{"down",	down},
	{NULL,		NULL}};


/*
	åκ
*/
LOCAL INT mk_repmess(B *buf, INT r, B *type, B *errmess)
{
	INT	n;
	B	*mess;

	switch(r) {
	  case 200:	mess = "OK";			break;
	  case 400:	mess = "Bad Request";		break;
	  case 404:	mess = "Not Found";		break;
	  default:	mess = "Internal Server Error";	break;
	}

	n = sprintf(buf, 
			"HTTP/1.1 %d %s" CRLF
			"Cache-Control: no-cache" CRLF
			"Connection: close" CRLF
			"Content-Length: %d" CRLF
			"Content-Type: %s" CRLF
			CRLF "%s",
			r, mess, strlen(errmess), type, errmess);
	return n;
}

/*
	եĥҤǥפ
*/
LOCAL B *ext2mtype(B *ext)
{
	if (strcasecmp(ext, ".html")==0)
		return "text/html";
	if (strcasecmp(ext, ".jpg")==0 ||
	    strcasecmp(ext, ".jpeg")==0)
	    	return "image/jpeg";
	if (strcasecmp(ext, ".png")==0)
		return "text/png";
	if (strcasecmp(ext, ".gif")==0)
		return "text/gif";
	return NULL;
}

/*
	
*/
LOCAL void session(INT sd)
{
	INT	i, n, r, fsz;
	B	*fname;
	B	*e;
	B	*mtype;
	B	path[PATH_MAX];
	FILE	*fp;
	B	*buf;
	B	*bufp;

	fp = NULL;
	buf = NULL;
	buf1[0] = 0;

	/*  (Ԥ򸡽Фޤ) */
	for (n = 0; n < sizeof(buf1) - 1;) {
		r = so_recv( sd, buf1 + n, sizeof(buf1) - 1 - n, 0 );
		if (r <= 0) break;
		n += r;
		buf1[n] = '\0';
		if (strstr( buf1, CRLF CRLF ) != NULL) break;	/* Ը */
	}
	if (n == 0) goto e1;
	P( "Recv %d bytes\n" "%.*s", n, n, buf1 );

	/* ǡ */
	if (strncmp(buf1, "GET /", 5) != 0) {
		n = mk_repmess( bufp = buf1, 400, "text/plain",
							"Bad Request" CRLF);
		goto dir_ret;
	}
	fname = &buf1[5];
	if (buf1[5] == ' ') {
		sprintf( fname, "index.html");
	} else {
		if ((e = strchr( fname, ' ')) != NULL)
			*e = '\0';
	}
	e = strrchr(fname, '.');
	if (e == NULL) {
		for(i = 0; key_func[i].key != NULL; i++) {
			if (strcmp(fname, key_func[i].key) == 0) {
				key_func[i].func();
				sprintf(buf2, autoback, key_func[i].key);
				n = mk_repmess( bufp = buf1, 200,
							"text/html", buf2);
				goto dir_ret;
			}
		}
		n = mk_repmess( bufp = buf1, 404, "text/plain",
							"Not Found" CRLF);
		goto dir_ret;
	}
	if ((mtype = ext2mtype(e)) == NULL) {
		n = mk_repmess( bufp = buf1, 404, "text/plain",
							"Not Found" CRLF);
		goto dir_ret;
	}
	snprintf(path, sizeof(path) - 1, "%s/%s", rootpath, fname);
	path[sizeof(path) - 1] = '\0';
	fp = fopen(path, "r");
	if (fp == NULL) {
		n = mk_repmess( bufp = buf1, 404, "text/plain",
							"Not Found" CRLF);
		goto dir_ret;
	}
	fseek(fp, 0, SEEK_END);
	fsz = ftell(fp);
	rewind(fp);
	buf = malloc(fsz + 512);
	if (buf == NULL) {
		n = mk_repmess( bufp = buf1, 500, "text/plain",
							"Memory Error" CRLF);
		goto dir_ret;
	}
	n = sprintf( buf1,
		"HTTP/1.1 200 OK" CRLF
		"Cache-Control: no-cache" CRLF
		"Connection: close" CRLF
		"Content-Length: %d" CRLF
		"Content-Type: %s" CRLF CRLF,
		fsz, mtype);
	strcpy(buf, buf1);
	r = fread(buf+n, fsz, 1, fp);
	if (r != 1) {
		n = mk_repmess( bufp = buf1, 500, "text/plain",
							"File read" CRLF);
		goto dir_ret;
	}
	bufp = buf;
	n += fsz;

dir_ret:

	/*  */
	for (i = 0; i < n;) {
		r = so_send( sd, bufp + i, n - i, 0 );
		if (r < 0) break;
		i += r;
	}
	P( "Send %d bytes\n", n);

	if (buf != NULL) free(buf);
	if (fp != NULL)	fclose(fp);

e1:	return;
}

/*
	TCP 
*/
LOCAL void tcp_serv(INT port)
{
	INT	sd, cd, er;
	socklen_t k;
	struct	sockaddr_in	addr;

	/* TCP åȤ */
	sd = so_socket( PF_INET, SOCK_STREAM, 0 );
	if (sd < 0) goto e2;

	/* ݡֹХɤ */
	memset( &addr, 0, sizeof(addr) );
	addr.sin_family = AF_INET;
	addr.sin_port = htons( port );	/* ݡֹ			*/
	addr.sin_addr.s_addr = htonl( INADDR_ANY );
	er = so_bind( sd, (struct sockaddr *)&addr, sizeof(addr));
	if (er < 0) goto e1;

	/* åȤ³Ԥˤ */
	er = so_listen( sd, 5 );
	if (er < 0) goto e1;

	for (;;) {
		// ³դ
		k = sizeof(addr);
		cd = so_accept( sd, (struct sockaddr *)&addr, &k );
P("so_accept()=%d\n", cd);
		if (cd < 0) continue;
		session( cd );
		so_close( cd );		/* åȤ򥯥	*/
	}

e1:	so_close( sd );	// åȤ򥯥
e2:	;
}

/*
	
*/
LOCAL void task_web(INT stacd, void *exinf)
{
	/* TCP  */
	tcp_serv( 80 );

	/* λ */
	tk_exd_tsk();
}

/*
	󥿡ͥåȾ
*/
LOCAL void net_show_inet(const struct ifaddrs *ifa)
{
	unsigned char str[32];
	struct sockaddr_in *sin;

	sin = (struct sockaddr_in *)ifa->ifa_addr;
	P("    inet:      %s\n", 
	       inet_ntop(AF_INET, &sin->sin_addr, str, sizeof(str)));

	if ((ifa->ifa_flags & IFF_BROADCAST) != 0) {
		sin = (struct sockaddr_in *)ifa->ifa_broadaddr;
		P("    broadcast: %s\n", 
		       inet_ntop(AF_INET, &sin->sin_addr, str, sizeof(str)));
	}

	sin = (struct sockaddr_in *)ifa->ifa_netmask;
	P("    netmask:   %s\n",
	       inet_ntop(AF_INET, &sin->sin_addr, str, sizeof(str)));
}

/*
	ͥåȥ
*/
LOCAL INT net_info(void)
{
	struct ifaddrs *ifa;
	void *buf;
	int len, count;
	char lastname[IFNAMSIZ];

	count = 0;

	len = so_getifaddrs(&ifa, NULL, 0);
	if (len < 0) {
		P("error: so_getifaddrs: %d(%d,%d)\n", len, MERCD(len), 
		       SERCD(len));
		goto dir_ret;
	}
	if (len == 0)	goto dir_ret;
	buf = malloc(len);
	if (buf == NULL) {
		goto dir_ret;
	}
	len = so_getifaddrs(&ifa, buf, len);
	if (len < 0) {
		P("error: so_getifaddrs: %d(%d,%d)\n", len, MERCD(len), 
		       SERCD(len));
		free(buf);
		goto dir_ret;
	}

	lastname[0] = '\0';
	for( ; ifa != NULL; ifa=ifa->ifa_next) {
		if (strncmp(ifa->ifa_name, lastname, IFNAMSIZ) != 0) {
			P("%s:\n", ifa->ifa_name);
			strncpy(lastname, ifa->ifa_name, IFNAMSIZ-1);
		}
		if (ifa->ifa_addr->sa_family == AF_INET) {
			net_show_inet(ifa);
			count++;
		}
	}
	free(buf);
dir_ret:
	return count;
}

/*
	web command
*/
void cmd_web(INT ac, B *av[])
{
	T_CTSK	ctsk;
	B	*p;

	if (tid != 0) {
		P("web: already started\n");
		goto err_ret;
	}
	if (ac >= 2) {
		rootpath[0] = '/';
		for (p = av[1]; *p && (*p == '/'); p++);
		strncpy(&rootpath[1], p, sizeof(rootpath)-2);
		rootpath[sizeof(rootpath)-1] = '\0';
		for (p = &rootpath[strlen(rootpath)-1];
			 (rootpath < p) && (*p == '/'); p--) {
			 *p = '\0';
		}
	} else {
		P("web: need root path\n");
		goto err_ret;
	}
	/* LED Ϣ֥Ȥκ */
	if (mkledobjs() < 0)
		goto err_ret;

	/* ͥåȥΥե졼 */
	if (net_info() == 0) {
		net_conf(NET_CONF_MACHINE, NET_CONF_DHCP);
		net_info();
	}

	memset(&ctsk, 0, sizeof(ctsk));

	SetOBJNAME(ctsk.exinf, "webt");
	ctsk.tskatr = TA_HLNG | TA_RNG0;
	ctsk.task = task_web;
	ctsk.itskpri = 100;
	ctsk.stksz = 8192;

	tid = tk_cre_tsk( &ctsk );	/* 		*/
	if (tid < E_OK) goto err_ret;

	tk_sta_tsk( tid, 0 );		/* ư		*/

err_ret:
	return;
}
